## spark 2012.0.deb

=== Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the entire Spark Toolset source distribution
# Build the SPARK Toolset on NT, Solaris, Linux or MacOS X
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

################################################################################
# DETERMINE HOST INFORMATION
################################################################################

# Determine which platform this Makefile is being run on.
TARGET:=$(shell uname -s)
GCC_TARGET:=$(shell gcc -dumpmachine)

# Canonicalize the target string.
ifeq ($(findstring CYGWIN_NT,${TARGET}),CYGWIN_NT)
   TARGET:=Windows
endif

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

BUILD_VICTOR:=false

# Windows.
ifeq (${TARGET},Windows)
    EXEEXTN:=.exe
    ifeq (${GCC_TARGET},i686-pc-mingw32)
        BUILD_VICTOR:=true
    endif
endif

# Sun.
ifeq (${TARGET},SunOS)
    EXEEXTN:=
endif

# Linux.
ifeq (${TARGET},Linux)
    EXEEXTN:=
    BUILD_VICTOR:=true
endif

# Darwin (Mac OS X).
ifeq (${TARGET},Darwin)
    EXEEXTN:=
    BUILD_VICTOR:=true
endif

################################################################################
# TARGETS
################################################################################

# Build all of the tools, copy them to bin, and clean up.
all:
	$(MAKE) makeall
	$(MAKE) copyall 
	$(MAKE) cleanall

################################################################################
# BUILDS
################################################################################

makeall:
	$(MAKE) -C sparklalr
	$(MAKE) -C examiner
	$(MAKE) -C simplifier
	$(MAKE) -C wraputility
	$(MAKE) -C checker
	$(MAKE) -C pogs
	$(MAKE) -C sparkclean
	$(MAKE) -C sparkformat
	$(MAKE) -C sparkmake
	$(MAKE) -C sparksimp
	$(MAKE) -C victor
	$(MAKE) -C victor_wrapper

copyall:
	cp ./examiner/spark${EXEEXTN}           ./bin/
	cp ./simplifier/spadesimp${EXEEXTN}     ./bin/
	cp ./simplifier/zombiescope${EXEEXTN}   ./bin/
	cp ./wraputility/wrap_utility${EXEEXTN} ./bin/
	cp ./checker/checker${EXEEXTN}          ./bin/
	cp ./pogs/pogs${EXEEXTN}                ./bin/
	cp ./sparkclean/sparkclean${EXEEXTN}    ./bin/
	cp ./sparkformat/sparkformat${EXEEXTN}  ./bin/
	cp ./sparkmake/sparkmake${EXEEXTN}      ./bin/
	cp ./sparksimp/sparksimp${EXEEXTN}      ./bin/
	cp ./victor_wrapper/victor${EXEEXTN}    ./bin/
ifeq (${BUILD_VICTOR},true)
	cp ./victor/alt-ergo/alt-ergo.opt       ./bin/alt-ergo${EXEEXTN}
	cp ./victor/vct/bin/vct${EXEEXTN}       ./bin/
endif
	cp ./victor/vct/run/prelude.fdl         ./share/spark/
	cp ./victor/vct/run/prelude.rul         ./share/spark/
	cp ./victor/vct/run/divmod.rul          ./share/spark/
ifeq (${TARGET},Windows)
	# Copy manifests for SICStus tools.
	cp ./simplifier/spadesimp${EXEEXTN}.manifest   ./bin/
	cp ./simplifier/zombiescope${EXEEXTN}.manifest ./bin/
	cp ./checker/checker${EXEEXTN}.manifest        ./bin/
	# Copy the required DLLs into bin.
	cp ./dlls/*                                    ./bin/
endif

cleanall:
	$(MAKE) -C sparklalr      clean
	$(MAKE) -C examiner       clean
	$(MAKE) -C simplifier     clean
	$(MAKE) -C wraputility    clean
	$(MAKE) -C checker        clean
	$(MAKE) -C pogs           clean
	$(MAKE) -C sparkclean     clean
	$(MAKE) -C sparkformat    clean
	$(MAKE) -C sparkmake      clean
	$(MAKE) -C sparksimp      clean
	$(MAKE) -C victor         clean
	$(MAKE) -C victor_wrapper clean

reallycleanall:
	rm -f ./bin/*
	rm -f ./share/spark/*
	$(MAKE) -C sparklalr      reallyclean
	$(MAKE) -C examiner       reallyclean
	$(MAKE) -C simplifier     reallyclean
	$(MAKE) -C wraputility    reallyclean
	$(MAKE) -C checker        reallyclean
	$(MAKE) -C pogs           reallyclean
	$(MAKE) -C sparkclean     reallyclean
	$(MAKE) -C sparkformat    reallyclean
	$(MAKE) -C sparkmake      reallyclean
	$(MAKE) -C sparksimp      reallyclean
	$(MAKE) -C victor         clean
	$(MAKE) -C victor_wrapper reallyclean

analyseall:
	-$(MAKE) -C sparklalr      self-analysis
	-$(MAKE) -C examiner       self-analysis
	-$(MAKE) -C simplifier     spxref
	-$(MAKE) -C wraputility    self-analysis
	-$(MAKE) -C checker        spxref
	-$(MAKE) -C pogs           self-analysis
	-$(MAKE) -C sparkclean     self-analysis
	-$(MAKE) -C sparkformat    self-analysis
	-$(MAKE) -C sparkmake      self-analysis
	-$(MAKE) -C victor_wrapper self-analysis

analyseallplain:
	-$(MAKE) -C sparklalr      self-analysis
	-$(MAKE) -C examiner       self-analysis
	-$(MAKE) -C simplifier     spxrefplain
	-$(MAKE) -C wraputility    self-analysis
	-$(MAKE) -C checker        spxrefplain
	-$(MAKE) -C pogs           self-analysis
	-$(MAKE) -C sparkclean     self-analysis
	-$(MAKE) -C sparkformat    self-analysis
	-$(MAKE) -C sparkmake      self-analysis
	-$(MAKE) -C victor_wrapper self-analysis

# Regenerate the reference results.
# (May be used to capture analysis of the current code base).
generaterereference: analyseallplain
	cp ./sparklalr/vcg/sparklalr.rep      ./analyse/referenceanalysis/sparklalr.rep
	cp ./examiner/vcg/mainunits95.rep     ./analyse/referenceanalysis/examiner.rep
	cp ./simplifier/spxref_undefined.txt  ./analyse/referenceanalysis/simplifier_spxref_undefined.txt
	cp ./wraputility/vcg/wrap_utility.rep ./analyse/referenceanalysis/wrap_utility.rep
	cp ./checker/spxref_undefined.txt     ./analyse/referenceanalysis/checker_spxref_undefined.txt
	cp ./pogs/vcg/pogs.rep                ./analyse/referenceanalysis/pogs.rep
	cp ./sparkclean/vcg/sparkclean.rep    ./analyse/referenceanalysis/sparkclean.rep
	cp ./sparkformat/vcg/sparkformat.rep  ./analyse/referenceanalysis/sparkformat.rep
	cp ./sparkmake/vcg/sparkmake.rep      ./analyse/referenceanalysis/sparkmake.rep
	cp ./victor_wrapper/vcg/victor.rep    ./analyse/referenceanalysis/victor.rep

################################################################################
# END-OF-FILE

=== checker/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

.NOTPARALLEL:

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Checker.
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=checker

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Darwin (Mac OS X).
ifeq (${TARGET},Darwin)
    # Modify PATH to pick up Apple's gcc before GNAT Pro
    PATH:=/usr/bin:${PATH}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN} build_manifest

# Note that the build assumes PATH is set to include SICSTUS binaries and (on
# Windows) MS VC Tools and LIB and INCLUDE are set to point at MS VC libraries
# and includes respectively.

${OUTPUT_NAME}${EXE_EXTN}: *.pro
	sicstus ${SICSTUS_SWITCHES} --goal "compile('checker.pro'), buildsav."
	spld ${SPLD_CONF} -o $@ --static --resources=${OUTPUT_NAME}${SAV_EXTN}=/${OUTPUT_NAME}${SAV_EXTN},${SICSTUS_LIBS}

# Manifest only required on Windows.
ifeq ($(findstring ${TARGET},Windows),${TARGET})
build_manifest:
	# Copy over the correct manifest file for this windows build.
	cp ${OUTPUT_NAME}.windows.manifest ${OUTPUT_NAME}${EXE_EXTN}.manifest
else
build_manifest:
endif

spxref:
	spxref -R -i spxref.pro checker.pro -w spxref_warning.txt -x spxref_cross.txt -m spxref_ported.txt -u spxref_undefined.txt

spxrefplain: spxref
	# Normalize anonymous prolog variables.
	sed -e 's/_[0-9][0-9]*/_/g' spxref_undefined.txt > spxref_undefined.txt.tmp
	mv spxref_undefined.txt.tmp spxref_undefined.txt

# Cleaning code base
#===================

clean:
	rm -f checker.sav checker.exp checker.ilk checker.lib checker.pdb

reallyclean: clean
	rm -f ${OUTPUT_NAME}${EXE_EXTN} ${OUTPUT_NAME}${EXE_EXTN}.manifest
	rm -f spxref_warning.txt spxref_cross.txt spxref_ported.txt spxref_undefined.txt

################################################################################
# END-OF-FILE

=== examiner/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Examiner
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=spark

# Location of root.
ROOT:=..

# Location of SPARKLALR parser generator binary
SPARKLALR:=${ROOT}/sparklalr/sparklalr

# Do not distribute files that must be prepped.
SPARK_PREPED:=examinerconstants.ads filesystem.adb

# Do not distribute files that are generated by the parser.
SPARK_PARSER:=sp_symbols.ads sp_parser_goto.adb sp_parser_goto.ads sp_relations.adb \
	sp_relations.ads sp_parser_actions.adb sp_parser_actions.ads \
	sp_productions.ads sp_expected_symbols.adb sp_expected_symbols.ads SPARK.PAR

FILES_GRAMMAR:=SPARK.LLA

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Files containing platform specific code that is handled by gnatprep
PREP_TARGETS:=${SPARK_PREPED} \
	indexmanager-cache.adb indexmanager-cache.shb \
	sli-xref.adb sli-xref.shb

# Debug info file produced by sparklalr (so they can be cleaned up)
PARSER_DEBUG:=SPARK.DGN SPARK.DSC SPARK.EKO SPARK.SYM SPARK.ACT

GCC_OPTS:=-fstack-check

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    # The --stack option is Windows specific, and supports setting the
    # 'StackCommitSize' and 'StackReserveSize'.  The interpretation of
    # these values is not treated consistently across different
    # Windows versions. Experience and testing on various Windows
    # versions has led to the current stack size being set at:
    # 0x10000000,0x100000 Do not change this value without considering
    # its full ramifications.
    LINK_ARGS:=-Xlinker --stack=0x10000000,0x100000
endif

# Solaris.
ifeq (${TARGET},SunOS)
    LINK_ARGS:=
endif

# Linux.
ifeq (${TARGET},Linux)
    LINK_ARGS:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    LINK_ARGS:=
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: prep parser
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} examiner -o $@ -cargs ${GCC_OPTS} -bargs ${BIND_OPTS} -largs ${LINK_ARGS}

self-analysis: prep parser
	-spark -report=mainunits95.rep -plain -dictionary_file=examiner @${OUTPUT_NAME}.smf

# Building parser
# ===============

parser: ${SPARK_PARSER}

${SPARK_PARSER}: ${FILES_GRAMMAR}
	# -p = Operate as parser
	# -s = Perform self-pack
	# -m = Accept multi comp
	# -v = Verbose
	# -du = Activate debug feature: dump memory
	${SPARKLALR} SPARK -p -s -m -v -du
	gnatchop -w SPARK.PAR

# Platform specific prepping
# ==========================

prep: ${PREP_TARGETS}

%.ads: %.aps
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} -DAddress_Size=${ADDRESS_SIZE} $< $@

%.adb: %.apb
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} -DAddress_Size=${ADDRESS_SIZE} $< $@

indexmanager-cache.adb: indexmanager-cache.SHADOW.adb
	gnatprep ${PREP_OPTS} -r -DSPARK=False $< $@

indexmanager-cache.shb: indexmanager-cache.SHADOW.adb
	gnatprep ${PREP_OPTS} -DSPARK=True $< $@

sli-xref.adb: sli-xref.SHADOW.adb
	gnatprep ${PREP_OPTS} -r -DSPARK=False $< $@

sli-xref.shb: sli-xref.SHADOW.adb
	gnatprep ${PREP_OPTS} -DSPARK=True $< $@

# Cleaning code base
# ==================

clean: residueclean standardclean

reallyclean: clean targetclean parserclean prepclean vcclean

residueclean:
	rm -f ${PARSER_DEBUG}

parserclean:
	rm -f ${SPARK_PARSER}

prepclean:
	rm -f ${PREP_TARGETS}

################################################################################
# END-OF-FILE

=== pogs/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for POGS
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=pogs

# Location of root.
ROOT:=..

SPARK_PREPED:=oscommandline.adb

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

# Files containing platform specific code that is handled by gnatprep
PREP_TARGETS:=${SPARK_PREPED}

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS}

self-analysis: preamble prep
	-spark -plain @${OUTPUT_NAME}.smf

# Initialisations
# ===============

preamble:
	$(MAKE) -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep: ${PREP_TARGETS}
	$(MAKE) -C ${ROOT}/examiner prep

%.ads: %.aps
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} $< $@

%.adb: %.apb
	gnatprep ${PREP_OPTS} -DTarget=${PREP_TARGET} $< $@

# Cleaning code base
# ==================

clean: residueclean standardclean

reallyclean: clean targetclean vcclean preamble
	$(MAKE) -C ${ROOT}/examiner reallyclean

residueclean:
	rm -f ${PREP_TARGETS}

################################################################################
# END-OF-FILE

=== simplifier/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Simplifier
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

.NOTPARALLEL:

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUTNAME_SIMPLIFIER:=spadesimp
OUTPUTNAME_ZOMBIESCOPE:=zombiescope

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Darwin (Mac OS X).
ifeq (${TARGET},Darwin)
    # Modify PATH to pick up Apple's gcc before GNAT Pro.
    PATH:=/usr/bin:${PATH}
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUTNAME_SIMPLIFIER}${EXE_EXTN} ${OUTPUTNAME_ZOMBIESCOPE}${EXE_EXTN} build_manifest

# Note that the build assumes PATH is set to include SICStus binaries and (on
# Windows) MS VC Tools and LIB and INCLUDE are set to point at MS VC libraries
# and includes respectively.

${OUTPUTNAME_SIMPLIFIER}${EXE_EXTN}: *.pro
	sicstus ${SICSTUS_SWITCHES} --goal "compile('simplifier.pro'), add_system_toolname('Simplifier'), buildsav_simplifier."
	spld ${SPLD_CONF} -o $@ --static --resources=${OUTPUTNAME_SIMPLIFIER}${SAV_EXTN}=/${OUTPUTNAME_SIMPLIFIER}${SAV_EXTN},${SICSTUS_LIBS}

${OUTPUTNAME_ZOMBIESCOPE}${EXE_EXTN}: *.pro
	sicstus ${SICSTUS_SWITCHES} --goal "compile('simplifier.pro'), add_system_toolname('ZombieScope'), buildsav_zombiescope."
	spld ${SPLD_CONF} -o $@ --static --resources=${OUTPUTNAME_ZOMBIESCOPE}${SAV_EXTN}=/${OUTPUTNAME_ZOMBIESCOPE}${SAV_EXTN},${SICSTUS_LIBS}

# Manifest only required on Windows.
ifeq ($(findstring ${TARGET},Windows),${TARGET})
build_manifest:
	# Copy over the correct manifest file for this windows build.
	cp ${OUTPUTNAME_SIMPLIFIER}.windows.manifest  ${OUTPUTNAME_SIMPLIFIER}${EXE_EXTN}.manifest
	cp ${OUTPUTNAME_ZOMBIESCOPE}.windows.manifest ${OUTPUTNAME_ZOMBIESCOPE}${EXE_EXTN}.manifest
else
build_manifest:
endif

spxref:
	spxref -R -i spxref.pro simplifier.pro -w spxref_warning.txt -x spxref_cross.txt -m spxref_ported.txt -u spxref_undefined.txt

spxrefplain: spxref
	# Normalize anonymous prolog variables.
	sed -e 's/_[0-9][0-9]*/_/g' spxref_undefined.txt > spxref_undefined.txt.tmp
	mv spxref_undefined.txt.tmp spxref_undefined.txt

# Cleaning code base
#===================

clean:
	rm -f spadesimp.sav spadesimp.exp spadesimp.ilk spadesimp.lib spadesimp.pdb
	rm -f zombiescope.sav zombiescope.exp zombiescope.ilk zombiescope.lib zombiescope.pdb

reallyclean: clean
	rm -f ${OUTPUTNAME_SIMPLIFIER}${EXE_EXTN} ${OUTPUTNAME_SIMPLIFIER}${EXE_EXTN}.manifest
	rm -f ${OUTPUTNAME_ZOMBIESCOPE}${EXE_EXTN} ${OUTPUTNAME_ZOMBIESCOPE}${EXE_EXTN}.manifest
	rm -f spxref_warning.txt spxref_cross.txt spxref_ported.txt spxref_undefined.txt

################################################################################
# END-OF-FILE

=== sparkclean/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for sparkclean
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparkclean

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}:
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS}

self-analysis:
	-spark -plain @${OUTPUT_NAME}.smf

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean

################################################################################
# END-OF-FILE

=== sparkformat/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for SPARKFormat
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparkformat

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

# Windows.
ifeq (${TARGET},Windows)
    # The --stack option is Windows specific, and supports setting the
    # 'StackCommitSize' and 'StackReserveSize'.  The interpretation of
    # these values is not treated consistently across different
    # Windows versions. Experience and testing on various Windows
    # versions has led to the current stack size being set at:
    # 0x10000000,0x100000 Do not change this value without considering
    # its full ramifications.
    LINK_ARGS:=-Xlinker --stack=0x10000000,0x100000
endif

# Solaris.
ifeq (${TARGET},SunOS)
    LINK_ARGS:=
endif

# Linux.
ifeq (${TARGET},Linux)
    LINK_ARGS:=
endif

# Darwin (Mac OS X 10.5 or 10.6, 64-bit).
ifeq (${TARGET},Darwin)
    LINK_ARGS:=
endif

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep parser
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS} -largs ${LINK_ARGS}

self-analysis: preamble prep parser
	-spark -plain @${OUTPUT_NAME}.smf

# Initialisations
# ===============

preamble:
	$(MAKE) -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	$(MAKE) -C ${ROOT}/examiner prep

parser:
	$(MAKE) -C ${ROOT}/examiner parser

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	$(MAKE) -C ${ROOT}/examiner reallyclean

################################################################################
# END-OF-FILE

=== sparklalr/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the SPARKLALR parser
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparklalr

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}:
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS}

self-analysis:
	-spark -plain @${OUTPUT_NAME}.smf

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean

################################################################################
# END-OF-FILE

=== sparkmake/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for SPARKMake
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparkmake

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep parser
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS}

self-analysis: preamble prep parser
	-spark -plain @${OUTPUT_NAME}.smf

# Initialisations
# ===============

preamble:
	$(MAKE) -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	$(MAKE) -C ${ROOT}/examiner prep

parser:
	$(MAKE) -C ${ROOT}/examiner parser

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	$(MAKE) -C ${ROOT}/examiner reallyclean

################################################################################
# END-OF-FILE

=== sparksimp/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for SPARKSimp
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=sparksimp

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM INDEPENDENT CONFIGURATION
################################################################################

LINK_ARGS:=new_expect.o

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: new_expect.o
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS} -largs ${LINK_ARGS}

new_expect.o: new_expect.c
	gcc -c -g -O2 -D${PREP_TARGET} $<

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean

################################################################################
# END-OF-FILE

=== victor/Makefile ===
#-------------------------------------------------------------------------------
#  (C) Altran Praxis Limited
#===============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for Victor
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

OUTPUT_NAME:=vct

ALT_ERGO:=alt-ergo
VICTOR:=vct

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# PLATFORM SPECIFIC CONFIGURATION
################################################################################

CPPFLAGS=
LDFLAGS=

# Windows.
ifeq (${TARGET},Windows)
    ifeq (${GCC_TARGET},i686-pc-mingw32)
        # on windows, let the compiler know the gmplib location
        CPPFLAGS="-I /gmp/include"
        LDFLAGS="-L /gmp/lib"
    endif
endif

################################################################################
# TARGETS
################################################################################

ALT_ERGO_DIR=$(shell ${TAR} ztf ${ALT_ERGO}-*.tar.gz | head -1)

# Target to build vct and alt-ergo
ifeq (${BUILD_VICTOR},true)
all: ${VICTOR}-target ${ALT_ERGO}-target
else
all:
endif

${VICTOR}-target:
	# Don't build Victor in parallel (-j). Missing dependencies in the Makefile.
ifeq (${TARGET},Darwin)
	$(MAKE) -C ${VICTOR}/src CPPFLAGS=${CPPFLAGS} LDFLAGS=${LDFLAGS} STATIC_GMP_MAC=1
else
	$(MAKE) -C ${VICTOR}/src CPPFLAGS=${CPPFLAGS} LDFLAGS=${LDFLAGS} STATIC_GMP=1
endif

${ALT_ERGO}-target: ${ALT_ERGO}
ifeq (${GCC_TARGET},i686-pc-mingw32)
	# on windows we mimick the build by copying the mingw binary provided
	# by the Alt-Ergo team to where a source built binary would have
	# appeared
	cp alt-ergo-*-mingw.exe ${ALT_ERGO}/alt-ergo.opt
else
	# by default, we build Alt-Ergo from the sources
	# Don't build Alt-Ergo in parallel (-j). Missing dependencies in the Makefile.
	cd ${ALT_ERGO} && ./configure
	$(MAKE) -C ${ALT_ERGO}
endif

${ALT_ERGO}:
	${TAR} zxvf ${ALT_ERGO}-*.tar.gz
	mv ${ALT_ERGO_DIR} ${ALT_ERGO}

# Cleaning code base
# ==================

clean:
	rm -Rf ${ALT_ERGO}
	-$(MAKE) -C ${VICTOR}/src clean
	rm -f ${VICTOR}/bin/${OUTPUT_NAME}${EXE_EXTN}

reallyclean: clean

################################################################################
# END-OF-FILE

=== victor_wrapper/Makefile ===
# -----------------------------------------------------------------------------
#  (C) Altran Praxis Limited
# -----------------------------------------------------------------------------
# 
#  The SPARK toolset is free software; you can redistribute it and/or modify it
#  under terms of the GNU General Public License as published by the Free
#  Software Foundation; either version 3, or (at your option) any later
#  version. The SPARK toolset is distributed in the hope that it will be
#  useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
#  Public License for more details. You should have received a copy of the GNU
#  General Public License distributed with the SPARK toolset; see file
#  COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
#  the license.
# 
# =============================================================================

################################################################################
# PURPOSE
#-------------------------------------------------------------------------------
# Makefile for the Victor Wrapper
# For Linux, Windows, Solaris or Mac OS X (aka Darwin).
################################################################################

################################################################################
# BUILD CONFIGURATION
################################################################################

# Name of the output program.
OUTPUT_NAME:=victor

# Location of root.
ROOT:=..

# Location of common.
COMMON:=${ROOT}/common

include ${COMMON}/Makefile.inc

################################################################################
# TARGETS
################################################################################

all: ${OUTPUT_NAME}${EXE_EXTN}

${OUTPUT_NAME}${EXE_EXTN}: preamble prep
	gnatmake -j${SPARKCPUS} ${GNATMAKE_OPTS} ${OUTPUT_NAME} -o $@ -bargs ${BIND_OPTS}

self-analysis: preamble prep
	-spark -plain @${OUTPUT_NAME}.smf

# Initialisations
# ===============

preamble:
	$(MAKE) -C ${ROOT}/examiner clean

# Platform specific prepping
# ==========================

prep:
	$(MAKE) -C ${ROOT}/examiner prep

# Cleaning code base
# ==================

clean: standardclean

reallyclean: clean targetclean vcclean preamble
	$(MAKE) -C ${ROOT}/examiner reallyclean

################################################################################
# END-OF-FILE

=== debian/changelog ===
spark (2012.0.deb-8) unstable; urgency=medium

  * Make the package compatible with both bison 2 and 3 and stop requiring
    bison 3.

 -- Євгеній Мещеряков <eugen@debian.org>  Mon, 16 Dec 2013 10:59:24 +0100

spark (2012.0.deb-7) unstable; urgency=medium

  * Fix required bison version (add 2:)

 -- Євгеній Мещеряков <eugen@debian.org>  Fri, 13 Dec 2013 00:31:48 +0100

spark (2012.0.deb-6) unstable; urgency=medium

  * New patch:
    - vct-bison-3-fix.diff - fix building with bison 3
  * Build-depend on bison >= 3
  * Standards-Version 3.9.5 — no changes needed

 -- Євгеній Мещеряков <eugen@debian.org>  Thu, 12 Dec 2013 22:00:22 +0100

spark (2012.0.deb-5) unstable; urgency=low

  * Use swi_prolog dh seqence to declare dependencies on SWI Prolog VM.

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 12 May 2013 23:41:17 +0200

spark (2012.0.deb-4) unstable; urgency=low

  * Upload to unstable

 -- Євгеній Мещеряков <eugen@debian.org>  Tue, 07 May 2013 22:00:47 +0200

spark (2012.0.deb-3) experimental; urgency=low

  * Rename prolog module settings to spark_prolog_settings to avoid conflict
    with newer versions of SWI prolog
  * Remove public declaration of predefined predicate subset/2 to avoid
    compilation problem with new SWI prolog

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 30 Sep 2012 21:46:13 +0200

spark (2012.0.deb-2) experimental; urgency=low

  * Override the architecture detection and handle all architectures as
    "Linux". This should fix an FTBFS on kfreebsd-*.

 -- Євгеній Мещеряков <eugen@debian.org>  Sun, 08 Jul 2012 23:55:54 +0200

spark (2012.0.deb-1) experimental; urgency=low

  * New upstream release
  * Upload to experimental
  * Update patches:
    - debian-architecture-detect.diff
    - examiner-architecture-bits.diff 
    - checker-makefile.diff 
    - no-alt-ergo.diff 
    - victor-no-static-gmp.diff
    - simplifier-makefile.diff
    - victor-use-env-opt-flags.diff
    - ada-use-evn-optflags.diff
    - victor-gmpxx-as-needed.diff
    - makefile-gnatmake-par-envvar.diff
    - ada-link-env-flags.diff
  * Remove patches:
    - make-dependencies.diff - not needed anymore
    - makefile-gnatmake-par-envvar.diff - use SPARKCPUS variable instead 
  * Standards-Version 3.9.3 — no changes required
  * Update debian/copyright
  * Do not install /usr/lib/spark/current/spark_/

 -- Євгеній Мещеряков <eugen@debian.org>  Sat, 30 Jun 2012 23:21:48 +0200

=== debian/control ===
Source: spark
Section: devel
Priority: optional
Maintainer: Євгеній Мещеряков <eugen@debian.org>
Build-Depends: debhelper (>= 8), gnat, swi-prolog-nox (>= 6.2.6-2~), libgmp-dev (>= 2:5.0.1+dfsg-7~), bison, flex
Standards-Version: 3.9.5
Homepage: http://libre.adacore.com/libre/tools/spark-gpl-edition/
Vcs-Git: git://git.debian.org/collab-maint/spark.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/spark.git

Package: spark
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${swi-prolog:Depends}, swi-prolog-nox
Suggests: gnat, alt-ergo
Description: SPARK programming language toolset
 SPARK is a formally-defined computer programming language based on the
 Ada programming language, intended to be secure and to support the
 development of high integrity software used in applications and systems
 where predictable and highly reliable operation is essential either for
 reasons of safety or for business integrity.
 .
 This package contains the tools necessary for checking if programs adhere
 to the SPARK rules and the tools to show freedom of runtime exceptions in
 those programs. To compile SPARK programs use any standards-compliant Ada
 compiler, such as GNAT.

=== debian/rules ===
#!/usr/bin/make -f

CXXFLAGS = -g -Wall
LDFLAGS = -g -Wall

ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CXXFLAGS += -O0
	ADA_OPT = -O0
else
	CXXFLAGS += -O2
	LDFLAGS += -O2
	ADA_OPT = -O2 -fdata-sections -ffunction-sections
	ADA_LINK = -Wl,--gc-sections
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SPARKCPUS = $(NUMJOBS)
else
	SPARKCPUS = 1
endif

export CXXFLAGS LDFLAGS ADA_OPT ADA_LINK SPARKCPUS

%:
	dh $@ --with swi_prolog

override_dh_auto_clean:
	$(MAKE) reallycleanall

override_dh_auto_build:
	# create empty directories that can be destroyed by git
	mkdir -p victor/vct/bin
	mkdir -p bin
	mkdir -p share/spark

	dh_auto_build CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	# nothing

override_dh_auto_test:
	# nothing

override_dh_install:
	dh_install
	rm -r debian/spark/usr/lib/spark/current/spark_

## spark analyzer-0.1.19

=== requirements.txt ===
setuptools>=60.0.0
tabulate>=0.8.10
requests>=2.28.1
configparser>=5.2.0
tqdm>=4.64.0

## spark dataloader-0.1.2

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = python -msphinx
SPHINXPROJ    = spark_dataloader
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)
